﻿Option Strict Off

Module mdlStricktOff

    Friend Sub DGVnachExcel(ByVal DGV As DataGridView)

        Dim xls_Appl As Microsoft.Office.Interop.Excel.Application               ' Excel Anwendung
        Dim xls_Mappe As Microsoft.Office.Interop.Excel.Workbook                 ' Excel Arbeitsmappe
        Dim xls_Blatt As Microsoft.Office.Interop.Excel.Worksheet                ' Excel Blatt (Tabelle)
        Dim Anzahlzeilen As Integer
        xls_Appl = New Microsoft.Office.Interop.Excel.Application() ' Excel Instanz bilden
        xls_Appl.Visible = True
        xls_Mappe = xls_Appl.Workbooks.Add()
        xls_Blatt = xls_Mappe.ActiveSheet
        With DGV
            For Spalte As Integer = 0 To .Columns.Count - 1
                xls_Blatt.Cells(1, Spalte + 1).Value = .Columns(Spalte).HeaderText
                xls_Blatt.Cells(1, Spalte + 1).Font.Bold = True
            Next

            Anzahlzeilen = .Rows.Count
            If .AllowUserToAddRows = True Then
                Anzahlzeilen = Anzahlzeilen - 1 ' Leerzeile abziehen
            End If
            For Zeile As Integer = 0 To Anzahlzeilen - 1
                For Spalte As Integer = 0 To .Columns.Count - 1
                    If Not .Rows(Zeile).Cells(Spalte).Value Is Nothing AndAlso .Rows(Zeile).Cells(Spalte).Value.GetType = GetType(Bitmap) Then
                        Dim img As Image
                        img = .Rows(Zeile).Cells(Spalte).Value
                        Clipboard.SetDataObject(img)
                        xls_Blatt.Cells(Zeile + 2, Spalte + 1).RowHeight = 38.25
                        xls_Blatt.Cells(Zeile + 2, Spalte + 1).ColumnWidth = 38.25
                        xls_Blatt.Cells(Zeile + 2, Spalte + 1).Select()
                        xls_Blatt.Paste()
                    ElseIf Not .Rows(Zeile).Cells(Spalte).Value Is Nothing AndAlso .Rows(Zeile).Cells(Spalte).Value.GetType = GetType(System.Byte()) Then
                        Dim img As Image
                        Dim by As Byte() = .Rows(Zeile).Cells(Spalte).Value
                        Using MS As New IO.MemoryStream(by)
                            img = Image.FromStream(MS)
                            Clipboard.SetDataObject(img)
                            xls_Blatt.Cells(Zeile + 2, Spalte + 1).RowHeight = 38.25
                            xls_Blatt.Cells(Zeile + 2, Spalte + 1).ColumnWidth = 38.25
                            xls_Blatt.Cells(Zeile + 2, Spalte + 1).Select()
                            xls_Blatt.Paste()
                        End Using

                    Else
                        xls_Blatt.Cells(Zeile + 2, Spalte + 1).Value _
                        = .Rows(Zeile).Cells(Spalte).FormattedValue.ToString
                    End If

                Next
            Next
        End With
        xls_Appl.Cells.Columns.AutoFit()
    End Sub
End Module
